diff --git a/plugins/thunderbolt/fu-plugin-thunderbolt.c b/plugins/thunderbolt/fu-plugin-thunderbolt.c
index 785b6b6768..d229cafe97 100644
--- a/plugins/thunderbolt/fu-plugin-thunderbolt.c
+++ b/plugins/thunderbolt/fu-plugin-thunderbolt.c
@@ -39,12 +39,6 @@ struct FuPluginData {
 	/* in the case we are updating */
 	UEventNotify   update_notify;
 	gpointer       update_data;
-
-	/* the timeout we wait for the device
-	 * to be updated to re-appear, in ms.
-	 * defaults to:
-	 *  FU_PLUGIN_THUNDERBOLT_UPDATE_TIMEOUT_MS */
-	guint timeout;
 };
 
 static gchar *
@@ -570,7 +564,6 @@ typedef struct UpdateData {
 	gboolean   have_device;
 	GMainLoop *mainloop;
 	const gchar *target_uuid;
-	guint      timeout_id;
 
 	GHashTable *changes;
 } UpdateData;
@@ -580,7 +573,6 @@ on_wait_for_device_timeout (gpointer user_data)
 {
 	UpdateData *data = (UpdateData *) user_data;
 	g_main_loop_quit (data->mainloop);
-	data->timeout_id = 0;
 	return FALSE;
 }
 
@@ -692,65 +684,6 @@ remove_leftover_devices (gpointer key,
 	fu_plugin_device_remove (plugin, dev);
 }
 
-static gboolean
-fu_plugin_thunderbolt_wait_for_device (FuPlugin  *plugin,
-				       FuDevice  *dev,
-				       GError   **error)
-{
-	FuPluginData *data = fu_plugin_get_data (plugin);
-	UpdateData up_data = { TRUE, };
-	g_autoptr(GMainLoop) mainloop = NULL;
-	g_autoptr(GHashTable) changes = NULL;
-
-	up_data.mainloop = mainloop = g_main_loop_new (NULL, FALSE);
-	up_data.target_uuid = fu_device_get_physical_id (dev);
-
-	/* this will limit the maximum amount of time we wait for
-	 * the device (i.e. 'dev') to re-appear. */
-	up_data.timeout_id = g_timeout_add (data->timeout,
-					    on_wait_for_device_timeout,
-					    &up_data);
-
-	/* this will capture the device added, removed, changed
-	 * signals while we are updating.  */
-	data->update_data = &up_data;
-	data->update_notify = on_wait_for_device_notify;
-
-	changes = g_hash_table_new_full (g_str_hash, g_str_equal, NULL, g_object_unref);
-	up_data.changes = changes;
-
-	/* now we wait ... */
-	g_main_loop_run (mainloop);
-
-	/* restore original udev change handler */
-	data->update_data = NULL;
-	data->update_notify = NULL;
-
-	if (up_data.timeout_id > 0)
-		g_source_remove (up_data.timeout_id);
-
-	if (!up_data.have_device) {
-		g_set_error_literal (error,
-				     FWUPD_ERROR,
-				     FWUPD_ERROR_NOT_FOUND,
-				     "timed out while waiting for device");
-		return FALSE;
-	}
-
-	g_hash_table_foreach (changes, remove_leftover_devices, plugin);
-
-	return TRUE;
-}
-
-/* internal interface  */
-
-void
-fu_plugin_thunderbolt_set_timeout (FuPlugin *plugin, guint timeout_ms)
-{
-	FuPluginData *data = fu_plugin_get_data (plugin);
-	data->timeout = timeout_ms;
-}
-
 /* virtual functions */
 
 void
@@ -762,8 +695,6 @@ fu_plugin_init (FuPlugin *plugin)
 	data->udev = g_udev_client_new (subsystems);
 	g_signal_connect (data->udev, "uevent",
 			  G_CALLBACK (udev_uevent_cb), plugin);
-
-	data->timeout = FU_PLUGIN_THUNDERBOLT_UPDATE_TIMEOUT_MS;
 }
 
 void
@@ -812,7 +743,6 @@ fu_plugin_update (FuPlugin *plugin,
 {
 	FuPluginData *data = fu_plugin_get_data (plugin);
 	const gchar *devpath;
-	guint64 status;
 	g_autoptr(GUdevDevice) udevice = NULL;
 	g_autoptr(GError) error_local = NULL;
 	gboolean install_force = (flags & FWUPD_INSTALL_FLAG_FORCE) != 0;
@@ -874,11 +804,31 @@ fu_plugin_update (FuPlugin *plugin,
 	}
 
 	fu_device_set_status (dev, FWUPD_STATUS_DEVICE_RESTART);
+	fu_device_set_remove_delay (dev, FU_PLUGIN_THUNDERBOLT_UPDATE_TIMEOUT_MS);
+	fu_device_add_flag (dev, FWUPD_DEVICE_FLAG_WAIT_FOR_REPLUG);
+
+	return TRUE;
+}
+
+gboolean
+fu_plugin_update_attach (FuPlugin *plugin,
+			 FuDevice *dev,
+			 GError **error)
+{
+	FuPluginData *data = fu_plugin_get_data (plugin);
+	const gchar *devpath;
+	guint64 status;
+	g_autoptr(GUdevDevice) udevice = NULL;
+	g_autoptr(GError) error_local = NULL;
 
-	/* the device will disappear and we need to wait until it reappears,
-	 * and then check if we find an error */
-	if (!fu_plugin_thunderbolt_wait_for_device (plugin, dev, error)) {
-		g_prefix_error (error, "could not detect device after update: ");
+	devpath = fu_device_get_metadata (dev, "sysfs-path");
+	udevice = g_udev_client_query_by_sysfs_path (data->udev, devpath);
+	if (udevice == NULL) {
+		g_set_error (error,
+			     FWUPD_ERROR,
+			     FWUPD_ERROR_NOT_FOUND,
+			     "could not find thunderbolt device at %s",
+			     devpath);
 		return FALSE;
 	}
 
